//+------------------------------------------------------------------+
//|                                            PeepingTom Sample.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+

extern double Lots = 0.1;
extern int MATrendPeriod = 50 ;
extern int Magic = 20110417 ;
extern int MinLen = 0 ;


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int TotalHistoryOrders() {
   int cnt = 0;
   int TotalOpenOrders = 0;
   cnt=OrdersHistoryTotal();
   if(cnt==0) {
      return(0);
   }
   else {
      for(;cnt>=0;cnt--) {
         RefreshRates();
         OrderSelect(cnt,SELECT_BY_POS,MODE_HISTORY);
         if(OrderSymbol()==Symbol()) {
            TotalOpenOrders++;
         }
      }
   }
   return(TotalOpenOrders);
}

int FoundRecentOpenedOrder(int TF) {
   int last_order_idx = (TotalHistoryOrders() - 1);
   OrderSelect(last_order_idx,SELECT_BY_POS,MODE_HISTORY);
   if (OrderOpenTime() >= iTime(Symbol(), TF, 1)) {
      return(TRUE);
   }
   return(FALSE);
}

int start()
  {
   double FibHigh = 0.618 ;
   double FibLow = 0.25 ;
   double myLength,EntryPoint,StopLvl,p2d ;
   double MaPrevious ;
   double TakeProfit,StopLoss,TP1,TP2 ;
   int cnt, ticket, total;
   bool Skip, IsUp, IsDown ;
   
   if (Point == 0.00001) p2d = 0.0001;
   else {
      if (Point == 0.001) p2d = 0.01;
      else p2d = Point;
   }

   myLength = MathAbs(Open[1]-Close[1]) ;      
   MaPrevious=iMA(NULL,0,MATrendPeriod,0,MODE_SMA,PRICE_CLOSE,1);
   StopLvl=MarketInfo(Symbol(),MODE_STOPLEVEL) ;
   if(StopLvl==0){StopLvl=Ask-Bid+Point ;}
   
   //is previous candle Bullish?
   if (Open[1]<Close[1] && (MathAbs(Open[1]-Close[1]) > MinLen*p2d) ) 
      {IsUp=true ;}
   else
      {IsUp=false;}

   if (Open[1]<Close[1] && (MathAbs(Open[1]-Close[1]) > MinLen*p2d) ) 
      {IsDown=true ;}
   else
      {IsDown=false;}

if (FoundRecentOpenedOrder(1440) == TRUE) {
    return(0);
}

   total=OrdersTotal();
   if(total<1) 
     {
      // no opened orders identified
      if(AccountFreeMargin()<(1000*Lots))
        {
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  
        }
      // Description of system as first presented see comments for interpretation  
      // check for long position (BUY) possibility
      //   LONG- previous candle close > 50-SMA. 
      //   previous candle is Bullish
      //   Entry point <=61.8% Fibonacci level of previous candle.
      //   Stop loss = 25.0% Fibonacci level of previous candle. 
      //   Take profit = lesser of SL x 2 or 5-period ATR.
      EntryPoint = NormalizeDouble( Close[1]-myLength*FibHigh,Digits ) ; //EP is a retrace 61% from up candle
      if( (Close[1]>MaPrevious) && (Ask<=EntryPoint) && IsUp ) //Price closed above MA price retraced below and last candle was up
        {
         Skip=FALSE ; //Previous Bar length too small for trade
         StopLoss=EntryPoint-NormalizeDouble(myLength*FibLow,Digits) ; //Stop loss if price continues down
         TP1 = Ask+2*NormalizeDouble(myLength*FibLow,Digits) ; //Add 50% op previous candle to entry Price for a take profit
         TP2 = Ask+iATR(Symbol(),0,5,0) ; //Add ATR(5) to entry price 
         if (TP1<TP2) {TakeProfit=TP1;} else {TakeProfit = TP2;} //use lower profit for close 
         if ( (Bid-StopLoss) <= StopLvl ) {Skip=TRUE;} //Check stoploss is valid
         if ( (TakeProfit-Bid) <= StopLvl ) {Skip=TRUE;} //check takeprofit is valid
         if (!Skip && myLength>=MinLen*p2d) //invalid takeprofit or stoploss no trade
         {
          Print(" StopLvl ",StopLvl," StopLoss ",StopLoss," TakeProfit ",TakeProfit," Length ",myLength," Bid ",Bid," Ask ",Ask) ;
          ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,StopLoss,TakeProfit,"PeepingTom",Magic,0,Green); //Broker may not like initial trade with S/L and T/P
          if(ticket>0)
            {
             if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
             PlaySound("Alert.wav");
            }
          else Print("Error opening BUY order : ",GetLastError()); 
         }//if Skip
         return(0); 
        }
        
      // check for short position (SELL) possibility
      //   SHORT- previous candle close < 50-SMA. 
      //   previous candle is Beareish
      //   Entry point >=25.0% Fibonacci level of previous candle. 
      //   Stop loss = 61.8% Fibonacci level of previous candle. 
      //   Take profit = lesser of SL x 2 or 5-period ATR.

      EntryPoint = NormalizeDouble(Close[1]+myLength*FibHigh,Digits) ; //Price retraced up 61.7% on Bull candle
      if( (Close[1] < MaPrevious) && (Bid >= EntryPoint) && IsDown ) //Price Closed below MA, price retraced above EntryPoint and last candle was down
        {
         Skip=FALSE ; //Previous Bar length too small for trade
         StopLoss=EntryPoint+NormalizeDouble(myLength*FibLow,Digits) ; //Stop loss price if price continues up from Entry Point
         TP1 = Bid-2*NormalizeDouble(myLength*FibLow,Digits) ; // Take Profit price 50% below Entry Price 
         TP2 = Bid-iATR(Symbol(),0,5,0) ; // Take Profit price Using ATR(5)
         if (TP1>TP2){TakeProfit=TP1;} else {TakeProfit = TP2;} //The higher price is the lesser profit in a SELL
         if ( (StopLoss-Ask) <= StopLvl ) {Skip=TRUE;} // Check values are valid
         if ( (Ask-TakeProfit) <= StopLvl ) {Skip=TRUE;}
         if (!Skip && myLength>=MinLen*p2d)
         {
          Print(" StopLvl ",StopLvl," StopLoss ",StopLoss," TakeProfit ",TakeProfit," Length ",myLength," Bid ",Bid," Ask ",Ask) ;
          ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,StopLoss,TakeProfit,"PeepingTom",Magic,0,Red);
          if(ticket>0)
            {
             if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
             PlaySound("Alert.wav");
            }
          else Print("Error opening SELL order : ",GetLastError()); 
         }//if Skip
         return(0); 
        }
      return(0);
     }
   return(0);
  }
// the end.